Scriptname ABBAShoutLearn extends Quest  

Shout Property MyShout Auto
Actor Property PlayerRef Auto
WordOfPower Property ABBA_1 Auto
WordOfPower Property ABBA_2 Auto
WordOfPower Property ABBA_3 Auto
Bool Property Word1Learned = False Auto Hidden
Bool Property Word2Learned = False Auto Hidden
Bool Property Word3Learned = False Auto Hidden

Event OnTrackedStatsEvent(String asStat, Int aiStatValue)
		if (asStat == "Dragon Souls Collected") && (aiStatValue >= 10) && !Word2Learned
			Debug.Trace("ABBA - Info: " + asStat + " event " + (aiStatValue As String) + " - ABBA word 2 learned")
				Utility.Wait(5)
				Debug.Notification("Happy Extra Super Orgasming and Look out for the 3rd word")
				Utility.Wait(5)
					If (Game.GetModbyName("ABBA-outfit.esp") != 255)
						;Quest ClothQuest = Game.GetFormFromFile(0xAF40, "ABBA-Outfit.esp") as Quest
						;ClothQuest.SetObjectiveDisplayed(10)
						Debug.Notification("...if you haven't already, you might want to stop by Lisbet's shop in Markarth and help her out.")
						Utility.Wait(5)
						Debug.Notification("Perhaps she will have something extra for you if you talk to her afterwards.")
					Endif
				game.TeachWord(ABBA_2)
				game.UnlockWord(ABBA_2)
				Word2Learned = true
		endif	
		if (asStat == "Dragon Souls Collected") && (aiStatValue >= 20) && !Word3Learned
			Debug.Trace("ABBA - Info: " + asStat + " event " + (aiStatValue As String) + " - ABBA word 3 learned")
				Utility.Wait(5)
				Debug.Notification("Happy Extra Super Orgasming, your new found power might even force people to have sex!")
				Utility.Wait(5)				
				game.TeachWord(ABBA_3)
				game.UnlockWord(ABBA_3)
			Word3Learned = true	
			UnregisterForTrackedStatsEvent()	
		endif		
EndEvent
