scriptname ABBAShoutSexTrigger extends ReferenceAlias

SexLabFramework property SexLab auto
ABBAShoutSex Property ABBASex auto
Actor property PlayerRef auto
Actor[] property Slots auto hidden

bool property _Locked auto hidden
bool property _PrepLocked auto hidden

bool function RegisterActor(Actor ActorRef)
	if SexLab.IsValidActor(ActorRef) && Slots.Length <= 3 && Slots.Find(ActorRef) == -1
		Slots = sslUtility.PushActor(ActorRef, Slots)
			if (Slots.Length >= 3)
				TriggerSex()
			endIf
		return true
	endIf
	Debug.trace("ABBAShoutSex info: failed to validate actor")
	return false
endFunction

Function TriggerCheck()
	if (Slots.Length >= 1) && !_Locked
		TriggerSex()
	else
		ResetSlots()
	endIf
EndFunction	

function TriggerSex()
	_Locked = true
	Slots = SexLab.SortActors(Slots)
	sslThreadModel Thread = SexLab.NewThread()
	if !Thread.AddActors(Slots)
		_Locked = false
		return 
	endIf
	Thread.SetHook("AbbaShoutSex")
	Thread.StartThread()
	ResetSlots()
endFunction

function ResetSlots()
	Actor[] emptyslots
	Slots = emptyslots
	_Locked = false
endFunction

event OnPlayerLoadGame()
	ResetSlots()
endEvent

event OnInit()
	OnPlayerLoadGame()
endEvent

Function ABBASSTListPrep()
	_PrepLocked = true
	Utility.Wait(1.0)
	Int i = 0
	Int c = StorageUtil.FormListCount(ABBASex, "ABBA_SEXACTORS")
	while i <= c
		while _Locked
			Utility.Wait(0.1)
		EndWhile	
		Actor akActor = StorageUtil.FormListGet(ABBASex, "ABBA_SEXACTORS", i) as Actor
		if akActor
			if RegisterActor(akActor)
			;
			endif
		EndIf
		i+=1
	EndWhile
	StorageUtil.FormListClear(ABBASex, "ABBA_SEXACTORS")
	TriggerCheck()
	_PrepLocked = false
EndFunction
