Scriptname ABBA_MainScript extends Quest 

ABBA_Messages Property ABBAMsg auto
ABBA_Morph Property Morph auto
ABBA_VoiceScript Property VoiceScript auto
ABBA_Target Property Target auto
SexLabFramework Property Sexlab auto
Actor property PlayerRef Auto
ABBA_MorphMgr Property mMger Auto

; private
int	property _myABBAKey	Auto
int	property _myABBARngKey	Auto
int property utility_key = 56 auto hidden
bool property bImmediateMorph = true auto hidden
bool property ABBAVoice = true Auto hidden
bool property ABBAOrgasm = false Auto hidden
bool property ABBAPo = false Auto hidden
bool property AbbaOutfit = false auto
bool property stripEnabled = false Auto hidden
bool property stripNPCEnabled = false Auto hidden
bool property DBOStrip = false Auto hidden
bool property ABBAOozeEnabled = true Auto Hidden
bool property bKeepUpdating = true Auto hidden
bool property SLInc = true Auto hidden
bool property bLewdUpsArousal = true Auto hidden
bool property bDaftSound = false Auto hidden
spell property Abba_Dress_Spell Auto
spell property Abba_Thong_Spell Auto
spell property ABBA_Lewd_Spell Auto
spell property ABBA_Nymph_Spell Auto
spell Property ABBA_Squirt_Spell Auto
spell Property ABBA_OrgasmDB Auto
spell Property Idle_Org_Spell Auto
spell property ABBAOoze auto
float Property	BeginSlider = 0.2 auto hidden
float Property	AbbaKeySlider = 90.0 auto hidden
float property OrgasmChance = 50.0 auto hidden
float property OrgasmThreshold = 0.9 auto hidden
float Property	StripSlider = 0.9 auto hidden
float Property	fStripChance = 50.0 auto hidden
float Property	NymphThreshold = 0.6 auto hidden 
float Property Range = 0.05 auto
float Property pOoze = 90.0 Auto hidden
Shout Property MyShout Auto
Sound property Squirting auto
Sound Property ABBABuzzSM auto
String Property ABBAMORPHS_KEY = "ABBA.esp" AutoReadOnly
;String Property AFRESTRICTED_ARMOR = "ABBA_MainScript.armor.restricted" autoreadonly hidden
String Property AFRESTRICTED_ARMORFL = "ABBA_MainScript.armor.restrictedfl" autoreadonly hidden
String Property CHEST_ARMOR = "ABBA_MainScript.armor.chest" autoreadonly hidden
String Property PANTY_ARMOR = "ABBA_MainScript.armor.panty" autoreadonly hidden
String Property PANTY2_ARMOR = "ABBA_MainScript.armor.panty2" autoreadonly hidden
String Property CHEST_ARMORNAME = "ABBA_MainScript.armor.chestname" autoreadonly hidden
String Property PANTY_ARMORNAME = "ABBA_MainScript.armor.pantyname" autoreadonly hidden
String Property PANTY2_ARMORNAME = "ABBA_MainScript.armor.panty2name" autoreadonly hidden
String Property BOOBSIZE = "ABBA_MainScript.amount" autoreadonly hidden
String Property ABBA_ACTORS = "ABBA_MainScript.actorlist" autoreadonly hidden
String Property BUZZED = "ABBA_MainScript.buzzed" autoreadonly hidden
String Property BUZZEDB = "ABBA_MainScript.buzzedb" autoreadonly hidden
String Property BUZZFACTOR = "ABBA_MainScript.buzzfactora" autoreadonly hidden
String Property BUZZBFACTOR = "ABBA_MainScript.buzzfactorb" autoreadonly hidden

MagicEffect Property EroticAura = none auto hidden
MagicEffect Property MysteriousAura = none auto hidden
MagicEffect Property LewdAura = none auto hidden
MagicEffect Property ExoticAura = none auto hidden
int Property iStripBody = 0x00000004 auto hidden
int Property iStripPanty = 0x00008000 auto hidden
int Property iStripPanty2 = 0x00080000 auto hidden

faction property AnimatingFaction auto
faction property ABBA_affected auto
faction property ArousalFaction auto
Faction property ABBA_Nympho_Faction Auto

Bool _LewdLocked
Bool _IALocked
Bool _DALocked

int Property iSlotMask1 = 0x00000004 Auto hidden ; BODY
int Property iSlotMask2 = 0 Auto hidden
int Property iSlotMask3 = 0 Auto hidden
int[] SlotMasks

Function SetSlotMasks()
	SlotMasks = new int[3]
	SlotMasks[0] = iSlotMask1
	SlotMasks[1] = iSlotMask2
	SlotMasks[2] = iSlotMask3
EndFunction	

Event OnKeyDown(int keyCode)
	if !Utility.IsInMenuMode()
		If (keyCode == _myABBAKey)
			if Input.IsKeyPressed(utility_key) && !_DALocked
				DecreaseArousal()
			elseIf !_IALocked
				IncreaseArousal()
			endIf	
		EndIf
		If (keyCode == _myABBARngKey)
			Actor tRef = Target.CrosshairTarget
			if !tRef
				return
			EndIf
			Morph.SetRngForActor(tRef)
			Float fRng = Utility.RandomInt(1, 10) as Float / 10
			Float TempSize = BeginSlider + fRng
			StorageUtil.SetFloatValue(tRef, BOOBSIZE, TempSize)
			ABBAResize(tRef, 0)
		EndIf		
	endif	
EndEvent

Event ABBASlEvent(Form fActor, int iType)
	Actor akActor = fActor as Actor
	;string akName = akActor.GetLeveledActorBase().GetName()
	;debug.notification("ABBA Info: sl event type " + iType + " adjusting morphs for " + akName)
	ABBAResize(akActor, iType)
EndEvent

float Function GetBoobSize(Actor a)
	Float fBooby = StorageUtil.GetFloatValue(a, BOOBSIZE)
	if fBooby
		return fBooby
	else
		return 0.0
	endIf	
EndFunction

float Function GetBuzzFactor(Actor a, string Type)
	Float fBuzz = StorageUtil.GetFloatValue(a, Type)
	if fBuzz
		return fBuzz
	else
		return 0.0
	endIf	
EndFunction

;----------------- Old Functions replaced with consolidated "ABBAResize" -----------------------;


Function ABBAResize(Actor akActor, int SLstage = 0)
	if (!akActor.Is3DLoaded() || akActor.IsDead() || !bKeepUpdating)
		return
	Endif
	Int iArousal = akActor.GetFactionRank(ArousalFaction)
	Float fArousal = iArousal As Float / 100
	Bool bLewdChar = (akActor.GetFactionRank(ABBA_Nympho_Faction) >= 1)
	if (AbbaOutfit && SLstage == 0)
		if akActor.HasMagicEffect(EroticAura)
			if (fArousal >= BeginSlider) 
				ABBA_Thong_Spell.cast(akActor)
			endIf
		endif
	EndIf
	if (akActor.GetLeveledActorBase().GetSex() == 0)
		return
	endif
		Armor current = StorageUtil.GetFormValue(akActor, CHEST_ARMOR) as ARMOR
		Armor current2 = StorageUtil.GetFormValue(akActor, PANTY_ARMOR) as ARMOR
		Armor current3 = StorageUtil.GetFormValue(akActor, PANTY2_ARMOR) as ARMOR
		Bool LewdButt = StorageUtil.FormListHas(self, BUZZED, akActor)
		Bool CuirassWorn = CheckSlots(akActor)
		Float CurrSize = GetBoobSize(akActor)
	
		bool bIsInDialogue = UI.IsMenuOpen("Dialogue Menu")
		bool bIsPlLooking = Game.IsLookingControlsEnabled()
		bool bRangeTooSmall	= bRangeCheck(CurrSize, fArousal)
		bool ArousalRange = bArousalRange(fArousal)
		bool Stripped = false
		bool isEligible = false
		bool isSLAnimating = akActor.GetFactionRank(AnimatingFaction) >= 1

	if (AbbaOutfit && SLstage == 0)
		LewdEffect(akActor, fArousal, LewdButt)
	EndIf
	if (bLewdChar && bLewdUpsArousal && (fArousal > NymphThreshold))
		ABBA_Nymph_Spell.cast(akActor)
	EndIf
	
	if (current || current2 || current3)
		Stripped = true
	EndIf

	if (akActor == PlayerRef) && (SLstage < 3) && ArousalRange && bRangeTooSmall && (!stripEnabled  || (stripEnabled && !Stripped && (fArousal < StripSlider)))
		return
	EndIf
	
	if (akActor != PlayerRef) && (SLstage < 3) && ArousalRange && bRangeTooSmall && (!stripNPCEnabled  || (stripNPCEnabled && !Stripped && (fArousal < StripSlider)))
		return
	EndIf

	if (fArousal < BeginSlider)  && (SLstage < 3) &&  (CurrSize < BeginSlider) && !Stripped
        return        
    Endif
	
	If (akActor == PlayerRef) && (fArousal > 0.99) && (!ABBAPo || !stripEnabled)
		If ABBAPo
		 ; ...
		elseIf stripEnabled
		 ; ...
		elseif (fArousal == CurrSize)
			return
		EndIf
	EndIf

	If (akActor != PlayerRef) && (fArousal > 0.99) && (!ABBAOrgasm || !stripNPCEnabled)
		If ABBAOrgasm
		 ; ...
		elseIf stripNPCEnabled
		 ; ...
		elseif (fArousal == CurrSize)
			return
		EndIf
	EndIf
	
	string akName = akActor.GetLeveledActorBase().GetName()
	int iLewd = SexLab.GetSkillLevel(akActor, "Lewd")
	if (iLewd >= 7) && !bLewdChar
		akActor.SetFactionRank(ABBA_Nympho_Faction, 1)
		if bDaftSound
			VoiceScript.Trumpets(akActor)
		EndIf	
		Debug.Notification(akName + " is now a nymphomaniac!")
	EndIf
	if (iLewd < 7) && bLewdChar
		akActor.SetFactionRank(ABBA_Nympho_Faction, -2)
		Debug.Notification(akName + " is a nympho no more")
	EndIf		
    if (fArousal > BeginSlider) || Stripped
        isEligible = True        
    Endif
    if  (isEligible && SLstage == 0)
		if akActor.GetFactionRank(ABBA_affected) < 1
			akActor.SetFactionRank(ABBA_affected, 1)
		endif
			if  (fArousal >= OrgasmThreshold) && (CurrSize >= OrgasmThreshold) && (Utility.RandomInt(0, 99) < OrgasmChance) && (akActor != PlayerRef) && ABBAOrgasm && bIsPlLooking && !bIsInDialogue && !isSLAnimating
				Orgasm(akActor, fArousal, CurrSize, LewdButt, CuirassWorn)
				return
			elseif  (fArousal >= OrgasmThreshold) && (CurrSize >= OrgasmThreshold) && (Utility.RandomInt(0, 99) < OrgasmChance) && (akActor == PlayerRef) && ABBAPo && bIsPlLooking && !bIsInDialogue && !isSLAnimating
				Orgasm(akActor, fArousal, CurrSize, LewdButt, CuirassWorn)
				return				
			elseif (fArousal >= StripSlider) && (CurrSize >= StripSlider) && stripEnabled && (akActor == PlayerRef) && !isSLAnimating && (Utility.RandomInt(0, 99) < fStripChance as int)
					Strip(akActor, akName, iArousal)
			elseif (fArousal >= StripSlider) && (CurrSize >= StripSlider) && stripNPCEnabled && (akActor != PlayerRef) && !SleepCheck(akActor) && !isSLAnimating && (Utility.RandomInt(0, 99) < fStripChance as int)
					Strip(akActor, akName, iArousal)
			elseif Stripped && (fArousal < StripSlider) && !SleepCheck(akActor) && !isSLAnimating
				if current3
					DressItem(akActor, akName, false, iArousal, iStripPanty2, PANTY2_ARMOR, PANTY2_ARMORNAME)
				elseif current2
					DressItem(akActor, akName, false, iArousal, iStripPanty, PANTY_ARMOR, PANTY_ARMORNAME)
				elseif current
					DressItem(akActor, akName, false, iArousal, iStripBody, CHEST_ARMOR, CHEST_ARMORNAME)
				Endif
			else 
				if (akActor == PlayerRef)
					ABBAMsg.ProcessMessage("pl", iArousal)
				else
					if SleepCheck(akActor)
						ABBAMsg.ProcessMessageNPC("sleep", 100, akActor, akName)
					else
						ABBAMsg.ProcessMessageNPC("npc", iArousal, akActor, akName)
					EndIf
				EndIf
			endif
			if (fArousal != CurrSize)
				CuirassWorn = CheckSlots(akActor)
				if (AbbaOutfit)
					if akActor.HasMagicEffect(MysteriousAura)
						Abba_Dress_Spell.cast(akActor)
					else 
						OozeEffect(akActor, fArousal)				
					endIf
				else 
					OozeEffect(akActor, fArousal)				
				endIf
				if ABBAVoice
					VoiceScript.Moan(akActor, iArousal)
				EndIf
				SendMorphUpdate(fArousal, akActor, CurrSize, true, LewdButt, CuirassWorn, false)
			EndIf	
				StorageUtil.SetFloatValue(akActor, BOOBSIZE, fArousal)
				StorageUtil.FormListAdd(self, ABBA_ACTORS, akActor, false)
			
    elseif  isEligible
		if  akActor.GetFactionRank(ABBA_affected) < 1
			akActor.SetFactionRank(ABBA_affected, 1)
		endif
		if (fArousal != CurrSize || SLstage == 3)
			OozeEffect(akActor, fArousal)
			SendMorphUpdate(fArousal, akActor, CurrSize, SLInc, LewdButt, CuirassWorn, false)
		endIf	
			StorageUtil.SetFloatValue(akActor, BOOBSIZE, fArousal)									   
			StorageUtil.FormListAdd(self, ABBA_ACTORS, akActor, false)

    else
		if (SLstage == 0) && !SleepCheck(akActor)
			if current3
				DressItem(akActor, akName, false, iArousal, iStripPanty2, PANTY2_ARMOR, PANTY2_ARMORNAME)
			elseif current2 
				DressItem(akActor, akName, false, iArousal, iStripPanty, PANTY_ARMOR, PANTY_ARMORNAME)
			elseif current
				DressItem(akActor, akName, false, iArousal, iStripBody, CHEST_ARMOR, CHEST_ARMORNAME)
			EndIf	
		elseif (SLstage == 0)
			if (akActor == PlayerRef) && (fArousal != CurrSize)
				ABBAMsg.ProcessMessage("pl", iArousal)
			elseif (fArousal != CurrSize)
				if SleepCheck(akActor)
					ABBAMsg.ProcessMessageNPC("sleep", 100, akActor, akName)
				else
					ABBAMsg.ProcessMessageNPC("npc", iArousal, akActor, akName)
				EndIf	
			EndIf
		EndIf
		if (fArousal != CurrSize || SLstage == 3)
			CuirassWorn = CheckSlots(akActor)
			if ABBAVoice 
				VoiceScript.Moan(akActor, iArousal)
			EndIf

			if (SLstage == 0)
				SendMorphUpdate(fArousal, akActor, CurrSize, true, LewdButt, CuirassWorn, false)
			else
				SendMorphUpdate(fArousal, akActor, CurrSize, SLInc, LewdButt, CuirassWorn, false)
			EndIf	
		endIf	
			StorageUtil.SetFloatValue(akActor, BOOBSIZE, fArousal)
			StorageUtil.FormListRemove(self, ABBA_ACTORS, akActor, true)
		if  akActor.GetFactionRank(ABBA_affected) >= 1
			akActor.SetFactionRank(ABBA_affected, -2)
		endif
	Endif
EndFunction

Function OozeEffect(Actor akActor, Float fA)
	If !akActor.Is3DLoaded() || !ABBAOozeEnabled
		return
	EndIf
		float pVal = pOoze/100
		if (fA >= pVal)
			ABBAOoze.cast(akActor)
		endif
EndFunction

Function LewdEffect(Actor akActor, Float fArousal, bool OnBuzzList)
	If (!akActor.Is3DLoaded() || !AbbaOutfit || _LewdLocked)
		return
	EndIf
	_LewdLocked = true
	Float fA = GetBuzzFactor(akActor, BUZZFACTOR)
	Float fAfade = (fA - 0.05)
	if (fAfade < 0.0)
		fAfade = 0.0
	EndIf
	Float fB = GetBuzzFactor(akActor, BUZZBFACTOR)
	Float fBfade = (fB - 0.05)
	if (fBfade < 0.0)
		fBfade = 0.0
	EndIf
		if LewdAura
			if akActor.HasMagicEffect(LewdAura)
				if fArousal <= fA
					ABBA_Butt_Util.ABBA_Buzz(akActor, fAfade, fA, ABBABuzzSM)
					StorageUtil.SetFloatValue(akActor, BUZZFACTOR, fAfade)					
				else
					ABBA_Butt_Util.ABBA_Buzz(akActor, fArousal, fA, ABBABuzzSM)
					StorageUtil.SetFloatValue(akActor, BUZZFACTOR, fArousal)
				EndIf	
				if fArousal >= 0.3
					ABBA_Lewd_Spell.cast(akActor)
				EndIf	
				if !OnBuzzList
					StorageUtil.FormListAdd(self, BUZZED, akActor, false)
				EndIf	
			else
				if OnBuzzList
					ABBA_Butt_Util.ABBA_Buzz(akActor, fAfade, fA, ABBABuzzSM)
					StorageUtil.SetFloatValue(akActor, BUZZFACTOR, fAfade)
					If fAfade == 0.0
						StorageUtil.FormListRemove(self, BUZZED, akActor, true)
					EndIf	
				Endif
			EndIf	
		EndIf	
		if ExoticAura
			bool OnBuzzBList = StorageUtil.FormListHas(self, BUZZEDB, akActor)
			if akActor.HasMagicEffect(ExoticAura)
				if fArousal <= fB
					ABBA_Butt_Util.ABBA_BuzzB(akActor, fBfade)
					StorageUtil.SetFloatValue(akActor, BUZZBFACTOR, fBfade)
				else
					ABBA_Butt_Util.ABBA_BuzzB(akActor, fArousal)
					StorageUtil.SetFloatValue(akActor, BUZZBFACTOR, fArousal)
				EndIf
				if !OnBuzzBList
					StorageUtil.FormListAdd(self, BUZZEDB, akActor, false)
				EndIf	
			else
				if OnBuzzBList
					ABBA_Butt_Util.ABBA_BuzzB(akActor, fBfade)
					StorageUtil.SetFloatValue(akActor, BUZZBFACTOR, fBfade)
					If fBfade == 0.0
						StorageUtil.FormListRemove(self, BUZZEDB, akActor, true)
					EndIf
				Endif
			EndIf	
		EndIf
	_LewdLocked = false
EndFunction

Function IncreaseArousal()
	_IALocked = true
		Actor IaRef = Target.CrosshairTarget
	if IaRef != none
		Int iArousal = IaRef.GetFactionRank(ArousalFaction)
		if 	iArousal > AbbaKeySlider
				string RefName = IaRef.GetLeveledActorBase().GetName()
				Debug.Notification(RefName + " Is already too Horny!")
				_IALocked = False
			return
		EndIf
		if (ABBAVoice) && (IaRef != none)
			VoiceScript.Moan(IaRef, iArousal)
		EndIf
		SendArousalUpdate(IaRef, 2)
		if bImmediateMorph
			Bool LewdButt = StorageUtil.FormListHas(self, BUZZED, IaRef)
			Bool CuirassWorn = CheckSlots(IaRef)			
			Float fArousal = IaRef.GetFactionRank(ArousalFaction) as float /100	
			Float fCurrent = GetBoobSize(IaRef)
			OozeEffect(IaRef, fArousal)
			SendMorphUpdate(fArousal, IaRef, fCurrent, false, LewdButt, CuirassWorn, false)
			StorageUtil.SetFloatValue(IaRef, BOOBSIZE, fArousal)
		EndIf
	else
		Int iArousal = PlayerRef.GetFactionRank(ArousalFaction)
		if 	iArousal > AbbaKeySlider 
				Debug.Notification("I'm already too Horny!")
				_IALocked = False
			return
		EndIf
		if (ABBAVoice)	
			VoiceScript.Moan(PlayerRef, iArousal)
		EndIf
		SendArousalUpdate(PlayerRef, 2)
		if bImmediateMorph		
			Bool LewdButt = StorageUtil.FormListHas(self, BUZZED, PlayerRef)
			Bool CuirassWorn = CheckSlots(PlayerRef)			
			Float fArousal = PlayerRef.GetFactionRank(ArousalFaction) as float /100	
			Float fCurrent = GetBoobSize(PlayerRef)
			OozeEffect(PlayerRef, fArousal)
			SendMorphUpdate(fArousal, PlayerRef, fCurrent, false, LewdButt, CuirassWorn, false)
			StorageUtil.SetFloatValue(PlayerRef, BOOBSIZE, fArousal)
		EndIf	
	endIf
	_IALocked = False
EndFunction	

Function DecreaseArousal()
	_DALocked = true
		Actor IaRef = Target.CrosshairTarget
	if IaRef != none
		Int iArousal = IaRef.GetFactionRank(ArousalFaction)
		if 	iArousal <= 0
			string RefName = IaRef.GetLeveledActorBase().GetName()
			Debug.Notification(RefName + " Is already at Zero arousal!")
			_DALocked = False
			return
		EndIf
		SendArousalUpdate(IaRef, -2)
		if bImmediateMorph		
			Bool LewdButt = StorageUtil.FormListHas(self, BUZZED, IaRef)
			Bool CuirassWorn = CheckSlots(IaRef)			
			Float fArousal = IaRef.GetFactionRank(ArousalFaction) as float /100	
			Float fCurrent = GetBoobSize(IaRef)
			OozeEffect(IaRef, fArousal)
			SendMorphUpdate(fArousal, IaRef, fCurrent, false, LewdButt, CuirassWorn, false)
			StorageUtil.SetFloatValue(IaRef, BOOBSIZE, fArousal)
		EndIf
	else
		Int iArousal = PlayerRef.GetFactionRank(ArousalFaction)
		if 	iArousal <= 0
			Debug.Notification("I'm already at Zero arousal!")
			_DALocked = False
			return
		EndIf
		SendArousalUpdate(PlayerRef, -2)
		if bImmediateMorph		
			Bool LewdButt = StorageUtil.FormListHas(self, BUZZED, PlayerRef)
			Bool CuirassWorn = CheckSlots(PlayerRef)			
			Float fArousal = PlayerRef.GetFactionRank(ArousalFaction) as float /100	
			Float fCurrent = GetBoobSize(PlayerRef)
			OozeEffect(PlayerRef, fArousal)
			SendMorphUpdate(fArousal, PlayerRef, fCurrent, false, LewdButt, CuirassWorn, false)
			StorageUtil.SetFloatValue(PlayerRef, BOOBSIZE, fArousal)
		EndIf
	endIf
	_DALocked = false
EndFunction

Function ResetABBAMorphs()
	debug.trace("ABBA info: Reseting morphs on all abba actors");
	int m = StorageUtil.FormListCount(self, ABBA_ACTORS)
	debug.trace("ABBA info: found " + m + " actors");
	Debug.Notification("Found " + m + " ABBA morphed actors")
	while m > 0
		m -= 1
		Actor NPC = StorageUtil.FormListGet(self, ABBA_ACTORS, m) as Actor
	if NPC
		if NPC.GetFactionRank(ABBA_affected) >= 1
			NPC.SetFactionRank(ABBA_affected, -2)
		endif
		StorageUtil.FormListAdd(self, "RESET_ACTORS", NPC, false)
		String NPCName = NPC.GetLeveledActorBase().GetName()
		NiOverride.ClearBodyMorphKeys(NPC, ABBAMORPHS_KEY)
		NiOverride.UpdateModelWeight(NPC)
		if stripNPCEnabled
			DressItem(NPC, NPCName, true, 0, iStripBody, CHEST_ARMOR, CHEST_ARMORNAME)
			DressItem(NPC, NPCName, true, 0, iStripPanty, PANTY_ARMOR, PANTY_ARMORNAME)
			DressItem(NPC, NPCName, true, 0, iStripPanty2, PANTY2_ARMOR, PANTY2_ARMORNAME)
		EndIf
		StorageUtil.SetFloatValue(NPC, BOOBSIZE, 0.0)
		if AbbaOutfit
			ABBA_Butt_Util.ABBA_RemoveOverlay(NPC, "\\ABBA\\butt.dds", "Body")
			ABBA_Butt_Util.ABBA_RemoveOverlay(NPC, "\\ABBA\\boobs.dds", "Body")
		EndIf	
		debug.trace("ABBA info: Removed morphs on " + NPCName);
	EndIf	
	EndWhile
	
	;repeat on player to make sure
	NiOverride.ClearBodyMorphKeys(PlayerRef, ABBAMORPHS_KEY)
	NiOverride.UpdateModelWeight(PlayerRef)
	if AbbaOutfit
		ABBA_Butt_Util.ABBA_RemoveOverlay(PlayerRef, "\\ABBA\\butt.dds", "Body")
		ABBA_Butt_Util.ABBA_RemoveOverlay(PlayerRef, "\\ABBA\\boobs.dds", "Body")
	EndIf	
	int n = StorageUtil.FormListCount(self, "RESET_ACTORS")
	if n != StorageUtil.FormListCount(self, ABBA_ACTORS) 
		Debug.Notification(n + " ABBA Actors Reset, the rest were dead or missing!")
	else 
		Debug.Notification("All ABBA Actors were Reset.")
	EndIf	
	StorageUtil.FormListClear(self, ABBA_ACTORS)
	StorageUtil.FormListClear(self, "RESET_ACTORS")
EndFunction	

Function ResetPlMorphs()
	if  PlayerRef.GetFactionRank(ABBA_affected) >= 1
		PlayerRef.SetFactionRank(ABBA_affected, -2)
	endif
	String PlayerName = PlayerRef.GetLeveledActorBase().GetName()
		NiOverride.ClearBodyMorphKeys(PlayerRef, ABBAMORPHS_KEY)
		NiOverride.UpdateModelWeight(PlayerRef)
	if stripEnabled
			DressItem(PlayerRef, PlayerName, true, 0, iStripBody, CHEST_ARMOR, CHEST_ARMORNAME)
			DressItem(PlayerRef, PlayerName, true, 0, iStripPanty, PANTY_ARMOR, PANTY_ARMORNAME)
			DressItem(PlayerRef, PlayerName, true, 0, iStripPanty2, PANTY2_ARMOR, PANTY2_ARMORNAME)
	EndIf
		if AbbaOutfit
			ABBA_Butt_Util.ABBA_RemoveOverlay(PlayerRef, "\\ABBA\\butt.dds", "Body")
			ABBA_Butt_Util.ABBA_RemoveOverlay(PlayerRef, "\\ABBA\\boobs.dds", "Body")
		EndIf
		StorageUtil.SetFloatValue(PlayerRef, BOOBSIZE, 0.0)
		StorageUtil.FormListRemove(self, ABBA_ACTORS, PlayerRef, true)
		debug.trace("ABBA info: Removed morphs on " + PlayerName);
		Debug.Notification("Removed ABBA morphs on " + PlayerName)
EndFunction	

Function Strip(Actor akActor, String akName, Int StArousal)
			int randomCloth = Utility.RandomInt(0, 1)
			if (randomCloth == 0) && CheckSlot(akActor, iStripBody)
					StripItem(akActor, akName, false, StArousal, iStripBody, CHEST_ARMOR, CHEST_ARMORNAME)
			elseif CheckSlot(akActor, iStripPanty)
					StripItem(akActor, akName, false, StArousal, iStripPanty, PANTY_ARMOR, PANTY_ARMORNAME)
				else 
					StripItem(akActor, akName, false, StArousal, iStripPanty2, PANTY2_ARMOR, PANTY2_ARMORNAME)
			Endif
EndFunction

Function StripItem(Actor akActor, string Name, Bool Quiet = false, Int StArousal, Int SlotMask, String ArmorType, String ArmorName)
		Armor aEquiped = akActor.GetWornForm(SlotMask) as Armor
		String ItemName = ""
		if aEquiped
			ItemName = aEquiped.GetName()
			if (WornObject.GetEnchantment(akActor, 0, SlotMask)) ;check for player-added enchantments/tempering
				ItemName = WornObject.GetDisplayName(akActor, 0, SlotMask)
			endif
		endIf
		Form fCurrent = StripSlot(akActor, SlotMask)
		If fCurrent
			StorageUtil.SetFormValue(akActor, ArmorType, fCurrent)
			StorageUtil.SetStringValue(akActor, ArmorName, ItemName)
			if !Quiet
				String Msg = ""
				if (ArmorType == CHEST_ARMOR)
					Msg = "strippedtop"
				else
					Msg = "strippedpanty"
				EndIf	
				if akActor == PlayerRef
					ABBAMsg.ProcessMessage(Msg, 0, ItemName)
				else
					ABBAMsg.ProcessMessageNPC("npc" + Msg, 0, akActor, Name, ItemName)
				endif	
			endif	
		else
			if (akActor == PlayerRef) && !Quiet
				ABBAMsg.ProcessMessage("pl", StArousal)
			elseif !Quiet
				ABBAMsg.ProcessMessageNPC("npc", StArousal, akActor, Name)
			EndIf
		Endif
EndFunction

Function DressItem(Actor akActor, string Name, bool Quiet = false, Int StArousal, Int SlotMask, String ArmorType, String ArmorName)
	bool OnList = StorageUtil.FormListHas(self, ABBA_ACTORS, akActor)
		Armor Stored = StorageUtil.GetFormValue(akActor, ArmorType) as Armor
		Armor aCurrent = akActor.GetWornForm(SlotMask) as Armor
	If !aCurrent
		if (Stored && !DBOStrip)
				akActor.equipItem(Stored, false, true)
			if !Quiet
				String ItemName = StorageUtil.GetStringValue(akActor, ArmorName)
				String Msg = ""
				if (ArmorType == CHEST_ARMOR)
					Msg = "unstrippedtop"
				else
					Msg = "unstrippedpanty"
				EndIf	
				if akActor == PlayerRef
					ABBAMsg.ProcessMessage(Msg, 0, ItemName)
				else
					ABBAMsg.ProcessMessageNPC("npc" + Msg, 0, akActor, Name, ItemName)
				endif
			EndIf
		EndIf	
	elseif (!Quiet && OnList)
		if akActor == PlayerRef
			ABBAMsg.ProcessMessage("pl", StArousal)
		else
			ABBAMsg.ProcessMessageNPC("npc", StArousal, akActor, Name)
		EndIf
	Endif
	if (Stored && !DBOStrip)	
		StorageUtil.UnsetFormValue(akActor, ArmorType)
		StorageUtil.UnsetStringValue(akActor, ArmorName)
	EndIf	
EndFunction

Function Orgasm(Actor OrgActor, Float fArousal, Float CurrSize, bool LewdButt, bool CuirassWorn)
	If !OrgActor.Is3DLoaded()
		return
	EndIf
	if OrgActor.HasSpell(MyShout)
		OrgasmShout(OrgActor)
		Utility.Wait(1.0)
	else
		if !SleepCheck(OrgActor)
			Idle_Org_Spell.cast(OrgActor)
		EndIf	
		ABBA_Squirt_Spell.cast(OrgActor)
			if ABBAVoice	
				VoiceScript.Moan(OrgActor, 100)
			endif	
		Squirting.Play(OrgActor)
		Utility.Wait(1.0)
	EndIf
	Float PostCum = (OrgActor.GetFactionRank(ArousalFaction) As Float / 100)
	if AbbaOutfit		
		LewdEffect(OrgActor, PostCum, LewdButt)
	EndIf
	SendMorphUpdate(PostCum, OrgActor, CurrSize, true, LewdButt, CuirassWorn, false)
	StorageUtil.SetFloatValue(OrgActor, BOOBSIZE, PostCum)
EndFunction	

Function OrgasmShout(Actor ShtActor)
	If !ShtActor.Is3DLoaded()
		return
	EndIf
		Spell EquippedItem = ShtActor.GetEquippedSpell(2)
		Shout EquippedShout = ShtActor.GetEquippedShout()
		int ShoutKey=Input.GetMappedKey("Shout",0x00)
		ShtActor.EquipShout(MyShout)
		Utility.wait(0.2)
		Input.HoldKey(ShoutKey)
		Utility.wait(0.5)
		Input.ReleaseKey(ShoutKey)
		ABBAMsg.ProcessMessage("plorg", 100)
		Utility.wait(2.0)
	if EquippedItem	
		ShtActor.EquipSpell(EquippedItem, 2)
	elseIF EquippedShout
		ShtActor.EquipShout(EquippedShout)
	else
		ShtActor.UnEquipShout(MyShout)
	EndIf
EndFunction	

Function SendArousalUpdate(Actor akRef, float Value)
	int SLA_Push = ModEvent.Create("slaUpdateExposure")
		ModEvent.PushForm(SLA_Push, akRef)
		ModEvent.PushFloat(SLA_Push, Value)
		ModEvent.Send(SLA_Push)
EndFunction


Function SendMorphUpdate(Float fAsend, Actor akAsend, Float fCSsend, Bool bSlIncrements, Bool bLBsend, Bool bCWsend, Bool bAFOnly)
	int ABBA_Push = ModEvent.Create("ABBAMorphUpdate")
		ModEvent.PushFloat(ABBA_Push, fAsend)
		ModEvent.PushForm(ABBA_Push, akAsend)
		ModEvent.PushFloat(ABBA_Push, fCSsend)
		ModEvent.PushBool(ABBA_Push, bSlIncrements)
		ModEvent.PushBool(ABBA_Push, bLBsend)
		ModEvent.PushBool(ABBA_Push, bCWsend)
		ModEvent.PushBool(ABBA_Push, bAFOnly)
		ModEvent.Send(ABBA_Push)
EndFunction


Form function StripSlot(Actor ActorRef, int SlotMask)
	Form ItemRef = ActorRef.GetWornForm(SlotMask)
	If ItemRef 
		If Sexlab.IsStrippable(ItemRef)
			ActorRef.UnequipItem(ItemRef, false, true)
			return ItemRef
		endif
	endif	
	return none
endFunction

bool function CheckSlot(Actor ActorRef, int SlotMask)
	Form ItemRef = ActorRef.GetWornForm(SlotMask)
	if ItemRef
		return true
	endif
	return false
endFunction

bool function CheckSlots(Actor ActorRef)
	int i = 0
	while i < 3
		if SlotMasks[i] != 0
			Form ItemRef = ActorRef.GetWornForm(SlotMasks[i])
			bool iAFdisabled = StorageUtil.FormListHas(self, AFRESTRICTED_ARMORFL, ItemRef)
			if ItemRef && !iAFdisabled
				return true
			endif
		endif	
		i += 1
	EndWhile	
	return false
endFunction

bool function IsSlotSet(Int Slot)
	int i = 0
	while i < 3
		if SlotMasks[i] != 0
			if (SlotMasks[i] == 0x00000004) && (Math.LogicalAnd(Slot, 0x00000004) == 0x00000004)
				return true
			ElseIf Slot == SlotMasks[i]
				return true
			EndIf	
		endif	
		i += 1
	EndWhile	
	return false
endFunction

bool Function bRangeCheck(Float CurrSize, Float fArousal)
	Float RangePlus = (CurrSize + Range)
	Float RangeMinus = (CurrSize - Range)
	if (fArousal <= RangePlus) && (fArousal >= RangeMinus) 
		return true
	EndIf
	return false	
EndFunction

Bool Function bArousalRange(Float fArousal)
	if (fArousal < 1.0) && (fArousal >= BeginSlider)
		return true 
	EndIf
	return false
EndFunction	

Form[] Function GetABBAArmors(Actor akRef)
	Form[] armorList
	If (akRef == None)
		return armorList
	EndIf
	int index = 0
	While index < SlotMasks.length
		Form tmpForm = akRef.GetWornForm(SlotMasks[index])
		If (tmpForm != None)
			If (armorList.Find(tmpForm) < 0)
				armorList = sslUtility.PushForm(tmpForm, armorList)
			EndIf
		EndIf
		index += 1
	EndWhile
	return armorList
EndFunction

Bool Function SleepCheck(Actor akActor)
	if (akActor.GetSleepState() == 3)
		return true
	endIf
	return false
endFunction	

