Scriptname ABBA_NPCRefScript extends ReferenceAlias 

ABBA_MainScript Property ABBAMain auto
ABBA_Morph Property Morph Auto
;ABBA_MorphMgr Property mMger Auto

Event OnUpdate()
	EquipedArmorAdjust()
EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	Armor ArmorRef = akBaseObject as Armor
	if ArmorRef
		if !ABBAMain.bKeepUpdating || !Morph.UseArmorFactor
			return
		endif
		int Slot = ArmorRef.GetSlotMask()
		if !ABBAMain.IsSlotSet(Slot)
			return
		EndIF
		RegisterForSingleUpdate(1.0)
	endIf
endEvent

Event OnObjectUnEquipped(Form akBaseObject, ObjectReference akReference)
	Armor ArmorRef = akBaseObject as Armor
	if ArmorRef
		if !ABBAMain.bKeepUpdating || !Morph.UseArmorFactor
			return
		endif
		int Slot = ArmorRef.GetSlotMask()
		if !ABBAMain.IsSlotSet(Slot)
			return
		EndIF	
		RegisterForSingleUpdate(1.0)	
	endIf
endEvent

Function EquipedArmorAdjust()
	Actor akActor = self.GetReference() as Actor
	if !akActor || (akActor.GetLeveledActorBase().GetSex() == 0)
		return
	EndIf
	Float arousal = akActor.GetFactionRank(ABBAMain.ArousalFaction) As Float / 100
	Float CurrSize = ABBAMain.GetBoobSize(akActor)
	if CurrSize == arousal
		CurrSize -= 0.1
	EndIf	
	Bool CuirassWorn = ABBAMain.CheckSlots(akActor)
	;mMger.ABBAMorphEvent(arousal, akActor, CurrSize, true, false, CuirassWorn, true)
	;Morph.DoinTheDo(arousal, akActor, CurrSize, true, false, CuirassWorn, true)
	ABBAMain.SendMorphUpdate(arousal, akActor, CurrSize, true, false, CuirassWorn, true)
	StorageUtil.SetFloatValue(akActor, ABBAMain.BOOBSIZE, arousal)
EndFunction	

