Scriptname ABBA_PlayerClothScript extends ReferenceAlias  

ABBA_MainScript Property ABBAMain auto
ABBA_ClockRefScript Property ABBAClock auto
ABBA_Morph Property Morph Auto
;ABBA_MorphMgr Property mMger Auto
Actor property PlayerRef Auto


Event OnUpdate()
	EquipedArmorAdjust()
EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	Armor ArmorRef = akBaseObject as Armor
	if ArmorRef
		if ((PlayerRef.GetLeveledActorBase().GetSex() == 0) || !ABBAMain.bKeepUpdating || !Morph.UseArmorFactor)
			return
		EndIf
		int Slot = ArmorRef.GetSlotMask()
		if !ABBAMain.IsSlotSet(Slot)
			return
		EndIF
		RegisterForSingleUpdate(1.0)
	endIf
endEvent

Event OnObjectUnEquipped(Form akBaseObject, ObjectReference akReference)
	Armor ArmorRef = akBaseObject as Armor
	if ArmorRef
		if ((PlayerRef.GetLeveledActorBase().GetSex() == 0) || !ABBAMain.bKeepUpdating || !Morph.UseArmorFactor)
			return
		EndIf
		int Slot = ArmorRef.GetSlotMask()
		if !ABBAMain.IsSlotSet(Slot)
			return
		EndIF
		RegisterForSingleUpdate(1.0)	
	endIf
endEvent

Function EquipedArmorAdjust()
		Float arousal = PlayerRef.GetFactionRank(ABBAMain.ArousalFaction) As Float / 100
		Float CurrSize = ABBAMain.GetBoobSize(PlayerRef)
		if CurrSize == arousal
			CurrSize -= 0.1
		EndIf		
		Bool CuirassWorn = ABBAMain.CheckSlots(PlayerRef)
		if !ABBAClock.acrPlResize
			Morph.DoAFNoArousalMorphs(PlayerRef, CuirassWorn)
		Else	
			;mMger.ABBAMorphEvent(arousal, PlayerRef, CurrSize, true, false, CuirassWorn, true)
			;Morph.DoinTheDo(arousal, PlayerRef, CurrSize, true, false, CuirassWorn, true)
			ABBAMain.SendMorphUpdate(arousal, PlayerRef, CurrSize, true, false, CuirassWorn, true)
		EndIf	
		StorageUtil.SetFloatValue(PlayerRef, ABBAMain.BOOBSIZE, arousal)
EndFunction
