Scriptname ABBA_Messages extends Quest 

String ABBAmessages = "../ABBA/status"
SexLabFramework Property SexLab Auto

Actor property PlayerRef Auto
bool property ABBAText = true Auto hidden

Function Notify(string out, bool mb=false)
	if (!ABBAText)
		return
	EndIf
	if mb
		Debug.MessageBox(out)
	else
		Debug.Notification(out)
	EndIf
EndFunction

String function LspName(Actor ref)
	Actor Lsp = SexLab.LastSexPartner(ref)
	if Lsp ;is there a last sex partner?
		string Lspn = CheckName(Lsp.GetLeveledActorBase().GetName())
		return Lspn	
	else
		return "none"
	endif	
EndFunction		

Function ProcessMessage(String opt, int arouse, String Item = "")
	if (!ABBAText)
		return
	EndIf	
	if Item
		String msgpre = GetMessage(GetPercentage(arouse), opt)
		String msg = ReplaceToken(msgpre, Item)
		Notify(msg)	

	elseif opt == "sl"
		String msg = GetMessage(GetPercentage(arouse), opt)
		Notify(msg)
		
	elseif (LspName(PlayerRef) != "none") && (GetPercentage(arouse) == 50)
		String msgpre = GetMessage(GetPercentage(arouse), "plsp")
		String msg = ReplaceToken(msgpre, LspName(PlayerRef))
		Notify(msg)		
	else
		String msg = GetMessage(GetPercentage(arouse), opt)
		Notify(msg)
	EndIf	
EndFunction

Function ProcessMessageNPC(String opt, int arouse, Actor NPCRef, String NPCName, String Item = "")
	String NamedNPC = CheckName(NPCName)
	if (!ABBAText)
		return
	EndIf
	if Item
		String msgpre = GetMessage(GetPercentage(arouse), opt)
		String msg = ReplaceToken(msgpre, Item)
		Notify(NamedNPC + msg)	

	elseif opt == "slnpc"
		String msg = GetMessage(GetPercentage(arouse), opt)
		Notify(NamedNPC + msg)
	
	elseif (LspName(NPCRef) != "none") && (GetPercentage(arouse) == 50)
		String msgpre = GetMessage(GetPercentage(arouse), "npcsp")
		String msg = ReplaceToken(msgpre, LspName(NPCRef))
		Notify(NamedNPC + msg)
	else
		String msg = GetMessage(GetPercentage(arouse), opt)
		Notify(NamedNPC + msg)
	EndIf	
EndFunction

String Function GetMessage(int percent, String type) 
	String skey = percent +"."
	String ArrayKey = skey + type
	int count = JsonUtil.StringListCount(ABBAMessages, ArrayKey)
	String[] list = PapyrusUtil.StringArray(count)
	JsonUtil.StringListSlice(ABBAMessages, ArrayKey, list)
	return list[Utility.RandomInt(0, list.length - 1)]
EndFunction

int Function GetPercentage(int original)
	If Original >= 100
		return 100
	ElseIf original >= 80
		return 80
	ElseIf original >= 50
		return 50
	ElseIf original >= 20
		return 20
	Else
		return 0
	EndIf
EndFunction 

String Function ReplaceToken(String raw, String Name)
	String result = raw
	int left = StringUtil.Find(result, "[")
	while left > -1
		int right = StringUtil.Find(result, "]", left + 1)
		if right > -1
			String token = StringUtil.Substring(result, left + 1, right - left - 1)
			If token == "tag"
				token = Name
			EndIf
			result = StringUtil.Substring(result, 0, left) + token + StringUtil.Substring(result, right + 1, StringUtil.GetLength(result) - right)
			left = StringUtil.Find(result, "[")
		else
			left = -1
		EndIf
	endWhile
	return result
EndFunction

String Function CheckName(String NameToShorten)
	int space = StringUtil.Find(NameToShorten, " ")
		if space && !CheckSurname(NameToShorten)
			string short = StringUtil.Substring(NameToShorten, 0, space); Shorten to the 1st name. 
			return short
		EndIf	
	return NameToShorten
EndFunction

Bool function CheckSurname(String NameToCheck)
	if StringUtil.Find(NameToCheck, "Guard") != -1
		return true
	EndIf	
	if StringUtil.Find(NameToCheck, "Soldier") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Bandit") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Imperial") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Stormcloak") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Legate") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Farmer") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Blood") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Vampire") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Slave") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Prisoner") != -1
		return true
	EndIf	
	if StringUtil.Find(NameToCheck, "Vigilant") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Mistress") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Knight") != -1
		return true
	EndIf	
	if StringUtil.Find(NameToCheck, "Warrior") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Reaver") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Cultist") != -1
		return true
	EndIf	
	if StringUtil.Find(NameToCheck, "Dragon") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Dremora") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Forsworn") != -1
		return true
	EndIf	
	if StringUtil.Find(NameToCheck, "Necromancer") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Mage") != -1
		return true
	EndIf
	if StringUtil.Find(NameToCheck, "Thalmor") != -1
		return true
	EndIf	
	if StringUtil.Find(NameToCheck, "Elf") != -1
		return true
	EndIf
	return false
EndFunction	
